(define-module (bugafriend user)
  #:use-module (bugafriend utils registry)
  #:use-module (bugafriend room)
  #:use-module (goblins)
  #:use-module (goblins ocapn ids)
  #:use-module (goblins actor-lib methods)
  #:use-module (srfi srfi-1)
  #:use-module (srfi srfi-9)
  #:export (^user
            make-room-data
            room-data?
            room-data-room
            room-data-presence))

(define-record-type <room-data>
  (make-room-data room presence)
  room-data?
  (room room-data-room)
  (presence room-data-presence))

(define (^user bcom name registry joined-room-data)
  (methods
   [(room-data) joined-room-data]
   [(make-room)
    (let* ((my-presence (spawn ^room-presence name))
           (room (spawn ^room my-presence))
           (room-data (make-room-data room my-presence)))
      (on (<- registry 'register room)
          (λ (id)
            (format #t "New room ID: ~a\n" (ocapn-id->string id))))
      (bcom (^user bcom name registry room-data)))]

   [(join-room room)
    (format #t "Connecting...\n")
    (let ((my-presence (spawn ^room-presence name)))
      (when joined-room-data
        (<-np (room-data-room joined-room-data) 'kick-user (room-data-presence joined-room-data)))

      (on (<- room 'add-user my-presence)
          (λ (_)
            (format #t "Joined room.\n")))

      (define room-data (make-room-data room my-presence))
      (bcom (^user bcom name registry room-data)))]

   [(leave-room room)
    (when (eq? room (room-data-room joined-room-data))
      (<-np room 'kick-user (room-data-presence joined-room-data))
      (bcom (^user bcom name registry #f)))]))
